﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private xui As XUI
	Private fx As JFX
	
	Public recM As Map
	Public rec  As List
	
	Public isInitialized As Boolean = False
	
	Private pnlCustomers As Pane
	
	Private RDC As jRDC
	
	Private dialogDel As B4XDialog
	
	Private dtFormat As String = "dd/MM/yyyy"
	Private tmFormat As String = "HH:mm:ss"
	
	Private dbDtFormat As String = "yyyy-MM-dd"
	Private dbTmFormat As String = "HH:mm:ss"
	
	Private lovSel As B4XTableSelections
	
	Public txtCode As TextField
	Private txtCustName As TextField
	Private txtAddress As TextField
	Private txtPhone1 As TextField
	Private txtPhone2 As TextField
	Private txtPhone3 As TextField
	Private txtEmail1 As TextField
	Private btnEmail1 As Button
	Private txtEmail2 As TextField
	Private btnEmail2 As Button
	Private txtComments As TextArea
	
	Private cvs As B4XCanvas
	Private tabSearch As B4XTable
	Private NameColumnLov(3) As B4XTableColumn
	
	Public  lblRecStatus As Label
	Private lblAddRec As Label
	Private lblDelRec As Label
	Private lblSaveRec As Label
	Private lblSearch As Label
	Private lblExecQuery As Label
	Private lblPrint As Label
	Private txtCustomerID As TextField
End Sub

Public Sub initialize
	DateTime.DateFormat = dtFormat
	DateTime.TimeFormat = tmFormat
	
	Private mPage As B4XMainPage = B4XPages.MainPage
	
	mPage.vpForms.LoadLayout("fCustomersPage","")
	
	RDC.Initialize
	recM.Initialize
	rec.Initialize
	
	stylePage
	initRecMap
	
	dialogDel.Initialize(Main.MainForm.RootPane)
	
	Sleep(0)
	txtCode.RequestFocus
	
	isInitialized = True
	
End Sub

Private Sub stylePage
	Dim pv As B4XView = xui.CreatePanel("")
	pv.SetLayoutAnimated(0, 0, 0, 1dip, 1dip)
	cvs.Initialize(pv)
End Sub

Private Sub styleTableLOV
	tabSearch.RowHeight = 40dip
	tabSearch.NumberOfFrozenColumns = 0
	
	NameColumnLov(0) = tabSearch.AddColumn("Κλειδί Πελάτη", tabSearch.COLUMN_TYPE_NUMBERS)
	NameColumnLov(1) = tabSearch.AddColumn("Κωδικός", tabSearch.COLUMN_TYPE_TEXT)
	NameColumnLov(2) = tabSearch.AddColumn("Ονοματεπώνυμο", tabSearch.COLUMN_TYPE_TEXT)
	
	tableUtils.SetColumnAlignment(tabSearch,"Ονοματεπώνυμο","LEFT")
	
	NameColumnLov(1).Searchable = True
	NameColumnLov(2).Searchable = True
	
	Sleep(0)
	For Each lbl As B4XView In Array(tabSearch.lblFromTo, tabSearch.lblNumber, tabSearch.lblBack, tabSearch.lblFirst, tabSearch.lblLast, tabSearch.lblNext)
		lbl.TextColor = xui.Color_White
	Next
	
	tabSearch.mBase.Color = xui.Color_ARGB(255,26,26,32)
	tabSearch.clvData.AsView.Color = xui.Color_ARGB(255,26,26,32)
	tabSearch.clvData.sv.ScrollViewInnerPanel.Color = xui.Color_ARGB(255,26,26,32)
	
	tabSearch.StringTo = "-"
	tabSearch.StringOutOf = "|"
	
	tabSearch.StringNoMatches = "Καμία Εγγραφή"
	tabSearch.StringMoreAvailable = "Περισσότερα..."
	
	tabSearch.SearchField.HintText = "Αναζήτηση"
	
	LoadDataLOV
	
	tabSearch.MaximumRowsPerPage = 20
	tabSearch.BuildLayoutsCache(tabSearch.MaximumRowsPerPage)
	
	lovSel.Initialize(tabSearch)
	lovSel.Mode = lovSel.MODE_SINGLE_CELL_PERMANENT
	
End Sub

Sub tabSearch_CellClicked (ColumnId As String, RowId As Long)
	lovSel.CellClicked(ColumnId, RowId)
End Sub

Public Sub ShowDialogLOV
	Private dialog As B4XDialog
	Private p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 1000dip, 900dip)
	p.LoadLayout("fListOfValues")
	dialog.Initialize(Main.MainForm.RootPane)
	dialog.BackgroundColor = xui.Color_RGB(20,20,30)
	dialog.ButtonsColor = xui.Color_RGB(0,120,190)
	'dialog.BlurBackground = True
	'dialog.BodyTextColor = 15794175
	dialog.PutAtTop = True
	'Wait For (dialog.ShowCustom(p, "Ok!", "No!", "")) Complete (Result As Int)
	dialog.ShowCustom(p, "OK", "", "ΑΚΥΡΟ")
	styleTableLOV
End Sub

Sub LoadDataLOV
	
'	Private req As DBRequestManager = RDC.CreateRequest(Me)
'	Private cmd As DBCommand = RDC.CreateCommand("select_custlov", Null)
'	
'	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
'	If j.Success Then
'		req.HandleJobAsync(j, "req")
'		Wait For (req) req_result(res As DBResult)
'		
'		tabSearch.SetData(res.Rows)
'		
'	End If
	
End Sub

Private Sub setRecStatus(recSts As String,stsText As String)
	lblRecStatus.Text = stsText
	lblRecStatus.Tag  = recSts
End Sub

Private Sub lblPrint_MousePressed (EventData As MouseEvent)
	doPrint
End Sub

Private Sub lblExecQuery_MousePressed (EventData As MouseEvent)
	doExecQuery
End Sub

Private Sub lblSearch_MousePressed (EventData As MouseEvent)
	doSearch
End Sub

Private Sub lblSaveRec_MousePressed (EventData As MouseEvent)
	doSaveRec
End Sub

Private Sub lblDelRec_MousePressed (EventData As MouseEvent)
	showDialogDel
End Sub

Private Sub lblAddRec_MousePressed (EventData As MouseEvent)
	doAddRec
End Sub

Public Sub doAddRec
	clearForm
	setRecStatus("INS",lblAddRec.Text)
End Sub

Public Sub doDelRec
	setRecStatus("DEL",lblDelRec.Text)
	
'	Private cmdStr As String
'	
'	Private req As DBRequestManager = RDC.CreateRequest(Me)
'	
'	cmdStr = "delete_cust"
'	
'	Private cmd As DBCommand = RDC.CreateCommand(cmdStr, Array As String(txtCustomerID.Text))
'	
'	Wait For (req.ExecuteCommand(cmd, Null)) JobDone(j As HttpJob)
'	If j.Success Then
'		Private info1 As String
'		info1 = "Η Διαγραφή της Εγγραφής έγινε!"
'		B4XPages.MainPage.lblMessage.Text = info1
'		clearForm
'		setRecStatus("INS",lblAddRec.Text)
'	Else
'		Private info1 As String
'		info1 = "Η Διαγραφή της Εγγραφής Απέτυχε!!!"
'		B4XPages.MainPage.lblMessage.Text = info1
'	End If
End Sub

Public Sub doSaveRec
	Private cmdStr As String
	
	setRecStatus("SAVE",lblSaveRec.Text)
	updFieldValues
	
	Private req As DBRequestManager = RDC.CreateRequest(Me)
	Dim jo As JavaObject = rec
	Private recP() As Object = jo.RunMethod("toArray", Null)
	
	If txtCustomerID.Text = "" Then
		cmdStr = "insert_cust"
	Else
		cmdStr = "update_cust"
	End If
	
	Private cmd As DBCommand = RDC.CreateCommand(cmdStr, recP)
	
	Wait For (req.ExecuteCommand(cmd, Null)) JobDone(j As HttpJob)
	If j.Success Then
		Private info1 As String
		If txtCustomerID.Text = "" Then
			info1 = "Η Εισαγωγή της Εγγραφής έγινε!"
		Else
			info1 = "Η Ενημέρωση της Εγγραφής έγινε!"
		End If
		B4XPages.MainPage.lblMessage.Text = info1
		setRecStatus("EXEQRY",lblExecQuery.Text)
		doSearchItem(txtCode.Text)
	Else
		Private info1 As String
		If txtCustomerID.Text = "" Then
			info1 = "Η Εισαγωγή της Εγγραφής Απέτυχε!!!"
		Else
			info1 = "Η Ενημέρωση της Εγγραφής Απέτυχε!!!"
		End If
		B4XPages.MainPage.lblMessage.Text = info1
	End If
End Sub

Public Sub doSearch
	clearForm
	setRecStatus("QRY",lblSearch.Text)
End Sub

Public Sub doExecQuery
	If lblRecStatus.Tag <> "QRY" Then Return
	setRecStatus("EXEQRY",lblExecQuery.Text)
	doSearchItem(txtCode.Text)
End Sub

Public Sub doPrint
	setRecStatus("PRINT",lblPrint.Text)
End Sub

public Sub showDialogDel
	If txtCustomerID.Text = "" Then Return
	dialogDel.Title = "Διαγραφή Εγγραφής"
	dialogDel.BackgroundColor = xui.Color_RGB(30,30,40)
	dialogDel.TitleBarColor = xui.Color_RGB(0,56,70)
	dialogDel.ButtonsColor = xui.Color_RGB(0,150,190)
	Wait For (dialogDel.Show("Θέλετε σίγουρα να Διαγράψετε την Εγγραφή;", "ΝΑΙ", "ΟΧΙ", "")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		doDelRec
	End If
End Sub

Private Sub clearForm
	For Each n As Node In pnlCustomers.GetAllViewsRecursive
		
		If n.Tag = "" Then Continue
		
		Try
			If n Is TextField Then
				Private t As TextField = n
				t.Text = ""
			End If
			
			If n Is TextArea Then
				Private r As TextArea = n
				r.Text = ""
			End If
			
			If n Is Label Then
				Private l As Label = n
				l.Text = ""
			End If
			
			If n Is DatePicker Then
				Private d As DatePicker = n
				d.DateTicks = DateTime.Now
			End If
			
		Catch
			Log(LastException)
			Continue
		End Try
	Next
	
	Sleep(0)
	txtCode.RequestFocus
	
End Sub

Private Sub fillFormData(res As DBResult)
	
	Private row() As Object = res.Rows.Get(0)
	
	For Each n As Node In pnlCustomers.GetAllViewsRecursive
		
		Private idx As Int = 0
		
		If n.Tag = "" Then Continue
		
		For Each col In res.Columns.Keys
			
			If n.Tag = col Then
				
				If n Is TextField Then
					Private t As TextField = n
					Private v As String = utils.ifNull(row(idx),"")
					If IsNumber(v) Then
						If v = "0" Or v = "0.0" Then
							v = ""
							'Else
							'	If recNums.ContainsKey(t.Tag) Then
							'		v = NumberFormat(v,1,2)
							'	End If
						End If
					End If
					t.Text = v
				End If
				
				If n Is TextArea Then
					Private r As TextArea = n
					Private v As String = utils.ifNull(row(idx),"")
					r.Text = v
				End If
			
				If n Is Label Then
					Private l As Label = n
					CSSUtils.SetStyleProperty(l,"-fx-padding","0 0 0 10")
					Private v As String = utils.ifNull(row(idx),"")
					If IsNumber(v) Then
						If v = "0" Or v = "0.0" Then
							v = ""
							'Else
							'	If recNums.ContainsKey(l.Tag) Then
							'		v = NumberFormat(v,1,2)
							'	End If
						End If
					End If
					l.Text = v
				End If
				
				If n Is DatePicker Then
					Private d As DatePicker = n
					If utils.ifNull(row(idx),"") <> "" Then
						d.DateTicks = row(idx)
					Else
						d.DateTicks = 0
					End If
				End If
				
				If n Is ComboBox Then
					Private c As ComboBox = n
					c.SelectedIndex = utils.ifNull(row(idx),0)
					c.Value = c.Items.Get(c.SelectedIndex)
				End If
				
				If n Is ColorPicker Then
					Private p As ColorPicker = n
					p.SelectedColor = fx.Colors.From32Bit(utils.ifNull(row(idx),xui.Color_RGB(0,150,200)))
				End If
				
			End If
			
			idx = idx + 1
			
		Next
		
	Next
	
	txtCode.RequestFocus
	
	If res.Rows.Size > 0 Then
		setRecStatus("EXEQRY",lblExecQuery.Text)
	Else
		setRecStatus("QRY",lblSearch.Text)
	End If
	
End Sub


Private Sub initRecMap
'	Private req As DBRequestManager = RDC.CreateRequest(Me)
'	Private cmd As DBCommand = RDC.CreateCommand("select_cust", Array As String("0"))
'	
'	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
'	If j.Success Then
'		req.HandleJobAsync(j, "req")
'		Wait For (req) req_result(res As DBResult)
'		
'		For Each col In res.Columns.Keys
'			recM.Put(col,"")
'		Next
'		
'	End If
	
End Sub

Private Sub doSearchItem(pCode As String)
'	Private req As DBRequestManager = RDC.CreateRequest(Me)
'	Private cmd As DBCommand = RDC.CreateCommand("select_cust", Array As String(pCode))
'	
'	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
'	If j.Success Then
'		req.HandleJobAsync(j, "req")
'		Wait For (req) req_result(res As DBResult)
'		
'		If res.Rows.Size > 0 Then
'			fillFormData(res)
'		End If
'		
'	End If
	
	setRecStatus("EXEQRY",lblExecQuery.Text)
	
End Sub

Private Sub updFieldValues
	
	For Each n As Node In pnlCustomers.GetAllViewsRecursive
		
		If (n.Tag = "" Or n.Tag = "SAVE" Or n.Tag = "id" Or n.Tag = "clear" Or n.Tag = False Or IsNumber(n.Tag) Or n.Tag.As(String).Length > 30) Then Continue
		
		'Log(n.Tag)
		
		If n Is TextField Then
			Private t As TextField = n
			recM.Put(t.Tag,utils.ifNull(t.Text,""))
		End If
		
		If n Is TextArea Then
			Private r As TextArea = n
			recM.Put(r.Tag,utils.ifNull(r.Text,""))
		End If
		
		If n Is Label Then
			Private l As Label = n
			recM.Put(l.Tag,utils.ifNull(l.Text,""))
		End If
				
		If n Is DatePicker Then
			Private d As DatePicker = n
			DateTime.DateFormat = dbDtFormat
			DateTime.TimeFormat = dbTmFormat
			Private dbDateTime As String
			dbDateTime = DateUtils.TicksToString(utils.ifNull(d.DateTicks,0))
			recM.Put(d.Tag,dbDateTime)
			DateTime.DateFormat = dtFormat
			DateTime.TimeFormat = tmFormat
		End If
				
		If n Is ComboBox Then
			Private c As ComboBox = n
			recM.Put(c.Tag,utils.ifNull(c.SelectedIndex,0))
		End If
		
	Next
	
	recM.Put("update_user","AUTO")
	
	recM.Remove("id")
	recM.Remove("update_date")
	
	If txtCustomerID.Text <> "" Then
		recM.Put("id",txtCustomerID.Text)
	End If
	
	Private i As Int = 0
	rec.Initialize
	
	For Each mk As String In recM.Keys
		Log(mk)
		rec.InsertAt(i,utils.ifNull(recM.Get(mk),""))
		i = i + 1
	Next
	
End Sub

Private Sub tabSearch_DataUpdated
	Dim ShouldRefresh As Boolean
	For Each Column As B4XTableColumn In Array (NameColumnLov(0), NameColumnLov(1), NameColumnLov(2))
		
		Dim MaxWidth As Int
		
		For i = 0 To tabSearch.VisibleRowIds.Size
			Dim pnl As B4XView = Column.CellsLayouts.Get(i)
			Dim lbl As B4XView = pnl.GetView(0)
			If lbl.Text = Null Then
				lbl.Text = ""
			End If
			MaxWidth = Max(MaxWidth, cvs.MeasureText(lbl.Text, lbl.Font).Width + 40dip)
		Next
		If MaxWidth > Column.ComputedWidth Or MaxWidth < Column.ComputedWidth - 80dip Then
			Column.Width = MaxWidth
			ShouldRefresh = True
		End If
		
	Next
	
	tableUtils.SetColumnAlignment(tabSearch,"Ονοματεπώνυμο","LEFT")
	
	If ShouldRefresh Then
		tabSearch.Refresh
	End If
	
End Sub

Private Sub btnEmail2_MousePressed (EventData As MouseEvent)
	
End Sub

Private Sub btnEmail1_MousePressed (EventData As MouseEvent)
	
End Sub