﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private RDC As jRDC
	Private xui As XUI
	
	Private cvs As B4XCanvas
	Private NameColumnLov(4) As B4XTableColumn
	Private tabSearch As B4XTable
	Private lovSel As B4XTableSelections
	Private dialog As B4XDialog
	Private p As B4XView
	
End Sub

Public Sub initialize
	RDC.Initialize
	initDialog
	styleTableLOV
	
	checkLowStockItems
End Sub

Public Sub checkLowStockItems
	Private cmdStr As String
	
	Private req As DBRequestManager = RDC.CreateRequest(Me)
	
	cmdStr = "select_lowstock"
	
	Private cmd As DBCommand = RDC.CreateCommand(cmdStr, Null)
	
	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_result(res As DBResult)
		
		If res.Rows.Size > 0 Then
			B4XPages.MainPage.lblStockBadge.Text = res.Rows.Size
			B4XPages.MainPage.lblStockBadge.Visible = True
		Else
			B4XPages.MainPage.lblStockBadge.Text = ""
			B4XPages.MainPage.lblStockBadge.Visible = False
		End If
		
		tabSearch.SetData(res.Rows)
		
		tabSearch.MaximumRowsPerPage = 20
		tabSearch.BuildLayoutsCache(tabSearch.MaximumRowsPerPage)
	
		lovSel.Initialize(tabSearch)
		lovSel.Mode = lovSel.MODE_SINGLE_CELL_PERMANENT
		
	End If
End Sub


Private Sub styleTableLOV
	tabSearch.RowHeight = 40dip
	tabSearch.NumberOfFrozenColumns = 0
	
	NameColumnLov(0) = tabSearch.AddColumn("Κωδικός Είδους", tabSearch.COLUMN_TYPE_TEXT)
	NameColumnLov(1) = tabSearch.AddColumn("Περιγραφή", tabSearch.COLUMN_TYPE_TEXT)
	NameColumnLov(2) = tabSearch.AddColumn("Τρέχον Απόθεμα", tabSearch.COLUMN_TYPE_NUMBERS)
	NameColumnLov(3) = tabSearch.AddColumn("Απόθεμα Alert", tabSearch.COLUMN_TYPE_NUMBERS)
	
	tableUtils.SetColumnAlignment(tabSearch,"Περιγραφή","LEFT")
	tableUtils.SetColumnAlignment(tabSearch,"Τρέχον Απόθεμα","RIGHT")
	tableUtils.SetColumnAlignment(tabSearch,"Απόθεμα Alert","RIGHT")
	
	NameColumnLov(1).Searchable = True
	NameColumnLov(2).Searchable = True
	
	Sleep(0)
	For Each lbl As B4XView In Array(tabSearch.lblFromTo, tabSearch.lblNumber, tabSearch.lblBack, tabSearch.lblFirst, tabSearch.lblLast, tabSearch.lblNext)
		lbl.TextColor = xui.Color_White
	Next
	
	Dim pv As B4XView = xui.CreatePanel("")
	pv.SetLayoutAnimated(0, 0, 0, 1dip, 1dip)
	cvs.Initialize(pv)
	
	tabSearch.mBase.Color = xui.Color_ARGB(255,26,26,32)
	tabSearch.clvData.AsView.Color = xui.Color_ARGB(255,26,26,32)
	tabSearch.clvData.sv.ScrollViewInnerPanel.Color = xui.Color_ARGB(255,26,26,32)
	
	tabSearch.StringTo = "-"
	tabSearch.StringOutOf = "|"
	
	tabSearch.StringNoMatches = "Καμία Εγγραφή"
	tabSearch.StringMoreAvailable = "Περισσότερα..."
	
	tabSearch.SearchField.HintText = "Αναζήτηση"
	
End Sub

Public Sub ShowDialogLowStock
	dialog.ShowCustom(p, "OK", "", "")
End Sub

Private Sub initDialog
	p = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 1000dip, 900dip)
	p.LoadLayout("fListOfValues")
	dialog.Initialize(Main.MainForm.RootPane)
	dialog.BackgroundColor = xui.Color_RGB(20,20,30)
	dialog.ButtonsColor = xui.Color_RGB(0,120,190)
	'dialog.BlurBackground = True
	'dialog.BodyTextColor = 15794175
	dialog.PutAtTop = True
	'Wait For (dialog.ShowCustom(p, "Ok!", "No!", "")) Complete (Result As Int)
End Sub


Private Sub tabSearch_DataUpdated
	Dim ShouldRefresh As Boolean
	For Each Column As B4XTableColumn In Array (NameColumnLov(0), NameColumnLov(1), NameColumnLov(2), NameColumnLov(3))
		Dim MaxWidth As Int
		For i = 0 To tabSearch.VisibleRowIds.Size
			Dim pnl As B4XView = Column.CellsLayouts.Get(i)
			Dim lbl As B4XView = pnl.GetView(0)
			If lbl.Text = Null Then
				lbl.Text = ""
			End If
			MaxWidth = Max(MaxWidth, cvs.MeasureText(lbl.Text, lbl.Font).Width + 40dip)
		Next
		If MaxWidth > Column.ComputedWidth Or MaxWidth < Column.ComputedWidth - 80dip Then
			Column.Width = MaxWidth
			ShouldRefresh = True
		End If
	Next
	
	tableUtils.SetColumnAlignment(tabSearch,"Περιγραφή","LEFT")
	tableUtils.SetColumnAlignment(tabSearch,"Τρέχον Απόθεμα","RIGHT")
	tableUtils.SetColumnAlignment(tabSearch,"Απόθεμα Alert","RIGHT")
	
	If ShouldRefresh Then
		tabSearch.Refresh
	End If
	
End Sub